
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red


extern string line = "0";
extern int    history = 5000;

extern int ExtDepth = 12;
extern int ExtDeviation = 5;
extern int ExtBackstep = 3;

datetime timee = 0;
double signal[];
double inarray[300];

int fail, w, p;

int init() { 
   IndicatorBuffers(1);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, signal);
   return(0); 
} 

int deinit() { 
   return(0); 
}

int start() {
   int price;
   double var;
   double buy_signal;
   double sell_signal;
   if(timee == Time[0]) return(0);
   timee = Time[0];
   if(ObjectFind(line) == -1) { 
      Alert("   |-          "); 
      return(0);
   }
   double time = ObjectGet(line, OBJPROP_TIME1);
   int bar = iBarShift(Symbol(), 0, time, FALSE);
   string name = "PNN_" + history + "_" + Symbol() + "_" + Period() + "_" + TimeYear(time) + "_" + TimeMonth(time) + "_"+TimeDay(time) + "__"+TimeHour(time) + "-" + TimeMinute(time) + ".txt";  
   string sum;
   sum = sum + "";
   p = bar + history;
   if(p > Bars) {
      p = Bars - 1; 
      Alert("  ->      "," ",Bars - bar);
   }
   fail=FileOpen(name,FILE_READ | FILE_WRITE,' '); 
   for (int w = p; w >= bar; w--) 
   {    
      for (int j = 0; j <= 4; j++) 
      {
         inarray[j] = iWPR(NULL, 0, 1, w + j + 1);    
      }         
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 5] = iWPR(NULL, 0, 3, w + j + 1);    
      }   
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 10] = iWPR(NULL, 0, 5, w + j + 1);    
      }   
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 15] = iWPR(NULL, 0, 8, w + j + 1);    
      }   
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 20] = iWPR(NULL, 0, 13, w + j + 1);    
      }              
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 25] = iWPR(NULL, 0, 1, w + j + 1) - iWPR(NULL, 0, 1, w + j + 2);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 30] = iWPR(NULL, 0, 3, w + j + 1) - iWPR(NULL, 0, 3, w + j + 2);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 35] = iWPR(NULL, 0, 5, w + j + 1) - iWPR(NULL, 0, 5, w + j + 2);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 40] = iWPR(NULL, 0, 8, w + j + 1) - iWPR(NULL, 0, 8, w + j + 2);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 45] = iWPR(NULL, 0, 13, w + j + 1) - iWPR(NULL, 0, 13, w + j + 2);    
      }       
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 50] = iRVI(NULL, 0, 1, MODE_MAIN, w + j + 1);    
      }    
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 55] = iRVI(NULL, 0, 3, MODE_MAIN, w + j + 1);    
      }
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 60] = iRVI(NULL, 0, 5, MODE_MAIN, w + j + 1);    
      }
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 65] = iRVI(NULL, 0, 8, MODE_MAIN, w + j + 1);    
      }
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 70] = iRVI(NULL, 0, 13, MODE_MAIN, w + j + 1);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 75] = iRVI(NULL, 0, 1, MODE_MAIN, w + j + 1) - iRVI(NULL, 0, 1, MODE_MAIN, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 80] = iRVI(NULL, 0, 3, MODE_MAIN, w + j + 1) - iRVI(NULL, 0, 3, MODE_MAIN, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 85] = iRVI(NULL, 0, 5, MODE_MAIN, w + j + 1) - iRVI(NULL, 0, 5, MODE_MAIN, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 90] = iRVI(NULL, 0, 8, MODE_MAIN, w + j + 1) - iRVI(NULL, 0, 8, MODE_MAIN, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 95] = iRVI(NULL, 0, 13, MODE_MAIN, w + j + 1) - iRVI(NULL, 0, 13, MODE_MAIN, w + j + 2);    
      }        
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 100] = iRSI(NULL, 0, 3, PRICE_OPEN, w + j + 1);    
      }       
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 105] = iRSI(NULL, 0, 5, PRICE_OPEN, w + j + 1);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 110] = iRSI(NULL, 0, 8, PRICE_OPEN, w + j + 1);    
      }       
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 115] = iRSI(NULL, 0, 3, PRICE_OPEN, w + j + 1) - iRSI(NULL, 0, 3, PRICE_OPEN, w + j + 2);    
      }       
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 120] = iRSI(NULL, 0, 5, PRICE_OPEN, w + j + 1) - iRSI(NULL, 0, 5, PRICE_OPEN, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 125] = iRSI(NULL, 0, 8, PRICE_OPEN, w + j + 1) - iRSI(NULL, 0, 8, PRICE_OPEN, w + j + 2);    
      }        
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 130] = iDeMarker(NULL, 0, 3, w + j + 1);    
      }      
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 135] = iDeMarker(NULL, 0, 5, w + j + 1);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 140] = iDeMarker(NULL, 0, 8, w + j + 1);    
      }   
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 145] = iDeMarker(NULL, 0, 3, w + j + 1) - iDeMarker(NULL, 0, 3, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 150] = iDeMarker(NULL, 0, 5, w + j + 1) - iDeMarker(NULL, 0, 5, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 155] = iDeMarker(NULL, 0, 8, w + j + 1) - iDeMarker(NULL, 0, 3, w + j + 2);    
      }           
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 160] = iAC(NULL, 0, w + j + 1);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 165] = iAC(NULL, 0, w + j + 1) - iAC(NULL, 0, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 170] = iAO(NULL, 0, w + j + 1);    
      }           
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 175] = iAO(NULL, 0, w + j + 1) - iAO(NULL, 0, w + j + 2);    
      }  
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 180] = iAD(NULL, 0, w + j + 1);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 185] = iMA(NULL, 0, 3, 0,MODE_EMA, PRICE_CLOSE, w + j + 1) - iMA(NULL, 0, 3, 0,MODE_EMA, PRICE_CLOSE, w + j + 2);    
      }       
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 190] = iMA(NULL, 0, 5, 0,MODE_EMA, PRICE_CLOSE, w + j + 1) - iMA(NULL, 0, 5, 0,MODE_EMA, PRICE_CLOSE, w + j + 2);    
      } 
      for (j = 0; j <= 4; j++) 
      {
         inarray[j + 195] = iMA(NULL, 0, 8, 0,MODE_EMA, PRICE_CLOSE, w + j + 1) - iMA(NULL, 0, 8, 0,MODE_EMA, PRICE_CLOSE, w + j + 2);    
      }  
      for (j = 0; j <= 99; j++) 
      {
         inarray[j + 200] = iWPR(NULL, 0, 20, w + j + 1);    
      }  
      for (j = 0; j <= 299; j++) 
      {
         sum = sum + inarray[j] + " ";         
      } 
      if (Close[w - 1] > Close[w]) {buy_signal = 1; sell_signal = 0;}
      if (Close[w - 1] < Close[w]) {buy_signal = 0; sell_signal = 1;}
      FileWrite(fail, StringTrimRight(sum), buy_signal, sell_signal);
      sum = "";
   }
   FileClose(fail);   
   return(0);
}